/*!
 * devextreme-react
 * Version: 24.2.7
 * Build date: Mon Apr 28 2025
 *
 * Copyright (c) 2012 - 2025 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-react
 */

"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const react_1 = require("react");
const react_dom_1 = require("react-dom");
const element_1 = require("./configuration/react/element");
const use_option_scanning_1 = require("./use-option-scanning");
const contexts_1 = require("./contexts");
const helpers_1 = require("./helpers");
const NestedOption = function NestedOption(props) {
    const { children } = props;
    const { elementDescriptor, ...restProps } = props;
    const { isTemplateRendering } = (0, react_1.useContext)(contexts_1.TemplateRenderingContext);
    if (!elementDescriptor || typeof document === 'undefined' || isTemplateRendering) {
        return null;
    }
    const usesNamedTemplate = elementDescriptor.TemplateProps?.some((prop) => props[prop.tmplOption] && typeof props[prop.tmplOption] === 'string');
    const { parentExpectedChildren, onChildOptionsReady: triggerParentOptionsReady, getOptionComponentKey, treeUpdateToken, } = (0, react_1.useContext)(contexts_1.NestedOptionContext);
    const [optionComponentKey] = (0, react_1.useState)(getOptionComponentKey());
    const optionElement = (0, element_1.getOptionInfo)(elementDescriptor, restProps, parentExpectedChildren);
    const mainContainer = (0, react_1.useMemo)(() => document.createElement('div'), []);
    const renderChildren = (0, helpers_1.hasExpectedChildren)(elementDescriptor) || usesNamedTemplate;
    const getHasTemplate = renderChildren
        ? () => !!mainContainer.childNodes.length
        : () => !!children;
    const [config, context,] = (0, use_option_scanning_1.useOptionScanning)(optionElement, getHasTemplate, treeUpdateToken, 'option');
    (0, react_1.useLayoutEffect)(() => {
        triggerParentOptionsReady(config, optionElement.descriptor, treeUpdateToken, optionComponentKey);
    }, [treeUpdateToken]);
    return renderChildren ? React.createElement(React.Fragment, {}, (0, react_dom_1.createPortal)(React.createElement(contexts_1.NestedOptionContext.Provider, {
        value: context,
    }, children), mainContainer)) : null;
};
exports.default = NestedOption;
